/**************************************************************************
 *                                                                        *
 *   Copyright (c) Digital Equipment  Corporation,  1991.   All  Rights   *
 *   Reserved.  Unpublished rights reserved under the copyright laws of   *
 *   the United States.                                                   *
 *                                                                        *
 *   The software  contained  on  this  media  is  proprietary  to  and   *
 *   embodies   the   confidential   technology  of  Digital  Equipment   *
 *   Corporation.  Possession, use, duplication or dissemination of the   *
 *   software  and media is authorized only pursuant to a valid written   *
 *   license from Digital Equipment Corporation.                          *
 *                                                                        *
 *   RESTRICTED RIGHTS LEGEND Use, duplication, or  disclosure  by  the   *
 *   U.S.   Government  is  subject  to  restrictions  as  set forth in   *
 *   Subparagraph  (c)(1)(ii)  of  DFARS  252.227-7013,   or   in   FAR   *
 *   52.227-19, as applicable.                                            *
 *                                                                        *
 **************************************************************************/
#ifdef SCCS
static char sccsid[]="@(#)user_data.c	5.2 Stardent 91/03/15";
#endif
/*
			Copyright (c) 1989 by
			Stardent Computer Inc.
			All Rights Reserved
	
	This software comprises unpublished confidential information of
	Stardent Computer Inc. and may not be used, copied or made
	available to anyone, except in accordance with the license
	under which it is furnished.
	
	This file is under sccs control at Stardent in:
	/sccs3.p/avs/examples/s.user_data.c
*/
#include <avs/avs.h>
#include <stdio.h>
#include "ex_user_data.h"

data_desc()
{
   int data_compute(), iparam;

   AVSset_module_name("user data c", MODULE_FILTER);
   AVSset_module_flags( COOPERATIVE | REENTRANT);

   /* Create an input port for the sample user data structure input */
   AVScreate_input_port("input 0", "struct ex_user_data",OPTIONAL);

   /* Create an output port for the result. This description is similar to
      the input */
   AVScreate_output_port("output 0", "struct ex_user_data");

   /* Add a parameter to wake up the module */
   AVSadd_parameter("poke me", "oneshot", 0, 0, 0);

   /* Add a parameter to print out the input when provided */
   iparam = AVSadd_parameter("printer", "string_block", "","", "");
   AVSconnect_widget(iparam, "text_block_browser");
   AVSadd_parameter_prop(iparam,"width", "integer", 4);
   AVSadd_parameter_prop(iparam,"height", "integer", 10);

   AVSset_compute_proc(data_compute);
   AVSload_user_data_types("../examples/ex_user_data.h");
}
	
data_compute(input,output,pokeme)
ex_user_data *input;
ex_user_data **output;
int pokeme;
{
   int i;
   char outbuf[1024];
   
   *output = (ex_user_data *) AVSdata_alloc("struct ex_user_data",0);
   (*output)->integer = 666;
   for (i = 0; i < 5; i++) {
      (*output)->farray[i] = i+1;
   }
   strcpy((*output)->str,"hello user defined data");

   if (input != NULL) { /* optionally connected */
      sprintf(outbuf,"");
      sprintf(outbuf,"Input User Data\n");
      sprintf(outbuf,"%sinteger = %d\n",outbuf, input->integer); 
      sprintf(outbuf,"%sstr = [ %s ]\n",outbuf, input->str);
      /* Compare the input to the output */
      if (input->integer != (*output)->integer)
	 AVSinfo("user_data: Scalar Integers different");
      if (strcmp(input->str,(*output)->str))
	 AVSinfo("user_data: Strings different");

      for (i = 0; i < 5; i++) {
	 sprintf(outbuf,"%s%d %f\n",outbuf, i, input->farray[i]);
	 /* Compare the input and output arrays */
	 if (input->farray[i] != (*output)->farray[i])
	    AVSinfo("user_data: Float (%d) different", i);
      }
      AVSmodify_parameter("printer", AVS_VALUE, outbuf, 0, 0);
   }
   return(1);
}

int ((*widget_mod_list[])()) = {
	data_desc
};

#define NMODS (sizeof(widget_mod_list) / sizeof(char *)) 

AVSinit_modules()
{
	AVSinit_from_module_list(widget_mod_list, NMODS);
}

